#! /bin/ksh

umask 022
PATH="/usr/local/bin:/usr/bin"
export PATH

# slide separator pattern
#
br="<br>---<br>"

# get last slide number
#
n=$(grep "$br" ss.html | wc -l)

# previous file
#
en="$n"
es=$(printf "%.4d" "$en")
e="$es.html"

# current file
#
fn="0"
fs="0000"
f="$fs.html"

# next file
#
gn="1"
gs="0001"
g="$gs.html"

# function to print arrows
#
print_arrows() {
  echo "<a href=\"0000.html\"><img align=middle src=\"up.gif\" alt=\"\"></a>
     <a href=\"$e\"><img align=middle src=\"left.gif\" alt=\"\"></a>
     <a href=\"$g\"><img align=middle src=\"right.gif\" alt=\"\"></a>"
}

# function to print header
#
print_header() {
  echo "<html><head><title>SS</title></head>
     <body bgcolor=white text=black>"
  print_arrows
  echo "<b>Batch Spreadsheet for C Programmers</b> - "
  m=0
  while [ "$m" -le "$n" ]; do
    if [ "$m" -eq "$fn" ]; then
      echo "$m"
    else
      ms=$(printf "%.4d" "$m")
      echo "<a href=\"$ms.html\">$m</a>"
    fi
    m=$(("$m" + 1))
  done
}



rm -f 00*.html

exec < "ss.html"

echo "${0}: creating file $f" 1>&2
exec > "$f"
print_header

while read -r line
do
  line=$(print -r "$line" | sed 's/^~/        /')

  if [ "$line" = "$br" ]; then
    echo "</body></html>"
    #
    en="$fn"; es="$fs"; e="$f"
    fn="$gn"; fs="$gs"; f="$g"
    if [ "$gn" -eq "$n" ]; then
      gn="0"
    else
      gn=$(("$gn" + 1))
    fi
    gs=$(printf "%.4d" "$gn")
    g="$gs.html"
    #
    echo "${0}: creating file $f" 1>&2
    exec > "$f"
    print_header
  elif [ "$line" = "<arrows>" ]; then
    print_arrows
  else
    print -r "$line" | sed 's/~/ /g'
  fi
done

echo "</body></html>"

exec 1>&2

weblint -x netscape 00*.html
